diff --git a/lib/hive/paths.rb b/lib/hive/paths.rb
new file mode 100644
index 00000000..dd7ed7d7
--- /dev/null
+++ b/lib/hive/paths.rb
@@ -0,0 +1,183 @@
+# frozen_string_literal: true
+
+require "fileutils"
+
+module Hive
+  # XDG-compliant global path resolver (KTD3 / U2).
+  #
+  # Two modes for *shared assets* (templates, schemas, agent profiles):
+  #   * source-checkout — executable root contains `templates/` + `lib/hive`
+  #   * installed       — assets live under the data dir or an
+  #                       executable-relative root (populated by installers)
+  #
+  # `HIVE_HOME` is a unified override: when set, config/state/data/cache all
+  # resolve under that directory (preserves existing tests + developer
+  # workflow). When unset, each category follows XDG Base Directory defaults.
+  module Paths
+    APP_NAME = "hive"
+    KNOWN_SYSTEM_DATA_DIRS = [
+      "/usr/share/hive",
+      "/usr/local/share/hive"
+    ].freeze
+
+    module_function
+
+    def config_dir
+      return hive_home_override if hive_home_override
+
+      File.join(xdg_base("XDG_CONFIG_HOME", "~/.config"), APP_NAME)
+    end
+
+    def data_dir
+      return hive_home_override if hive_home_override
+
+      File.join(xdg_base("XDG_DATA_HOME", "~/.local/share"), APP_NAME)
+    end
+
+    def state_dir
+      return hive_home_override if hive_home_override
+
+      File.join(xdg_base("XDG_STATE_HOME", "~/.local/state"), APP_NAME)
+    end
+
+    def cache_dir
+      return hive_home_override if hive_home_override
+
+      File.join(xdg_base("XDG_CACHE_HOME", "~/.cache"), APP_NAME)
+    end
+
+    # Back-compat alias used by Config / Daemon / Bot for the "global home"
+    # concept. Prefer the specific *_{dir} helpers for new code.
+    def hive_home
+      hive_home_override || state_dir
+    end
+
+    def global_config_path
+      File.join(config_dir, "config.yml")
+    end
+
+    def channel_marker_path
+      File.join(data_dir, "install-channel.yml")
+    end
+
+    def ensure_config_dir!
+      FileUtils.mkdir_p(config_dir)
+      config_dir
+    end
+
+    def ensure_state_dir!
+      FileUtils.mkdir_p(state_dir)
+      state_dir
+    end
+
+    def ensure_data_dir!
+      FileUtils.mkdir_p(data_dir)
+      data_dir
+    end
+
+    def ensure_cache_dir!
+      FileUtils.mkdir_p(cache_dir)
+      cache_dir
+    end
+
+    # Root of the hive install that contains lib/ + templates/.
+    # Priority: HIVE_HOME (if it looks like a checkout/install) →
+    # executable-relative root → known system data dirs → data_dir →
+    # source-checkout repo root (relative to this file).
+    def install_root
+      if hive_home_override && asset_root?(hive_home_override)
+        return hive_home_override
+      end
+
+      exec_root = executable_relative_root
+      return exec_root if exec_root && asset_root?(exec_root)
+
+      KNOWN_SYSTEM_DATA_DIRS.each do |candidate|
+        return candidate if asset_root?(candidate)
+      end
+
+      return data_dir if asset_root?(data_dir)
+
+      repo_root
+    end
+
+    def source_checkout?
+      asset_root?(repo_root) && File.expand_path(install_root) == File.expand_path(repo_root)
+    end
+
+    def installed?
+      !source_checkout?
+    end
+
+    def templates_dir
+      File.join(install_root, "templates")
+    end
+
+    def schemas_dir
+      File.join(install_root, "schemas")
+    end
+
+    def template_path(name)
+      File.join(templates_dir, name)
+    end
+
+    def repo_root
+      # lib/hive/paths.rb → lib/hive → lib → repo root
+      File.expand_path("../..", __dir__)
+    end
+
+    def asset_root?(path)
+      return false if path.nil? || path.empty?
+
+      File.directory?(File.join(path, "templates")) &&
+        (File.directory?(File.join(path, "lib", "hive")) ||
+         File.file?(File.join(path, "bin", "hive")) ||
+         File.file?(File.join(path, "hive")))
+    end
+
+    def executable_relative_root
+      # Packaged layouts:
+      #   <prefix>/bin/hive  + <prefix>/templates
+      #   <prefix>/hive      + <prefix>/share/hive/templates  (brew libexec)
+      #   /usr/bin/hive      + /usr/share/hive/templates      (AUR)
+      bin = resolve_executable_path
+      return nil unless bin
+
+      dir = File.dirname(File.expand_path(bin))
+      candidates = [
+        File.expand_path("..", dir),                       # <prefix> when bin is <prefix>/bin/hive
+        dir,                                               # bin and assets co-located
+        File.expand_path("../share/hive", dir),            # /usr/bin → /usr/share/hive
+        File.expand_path("../../share/hive", dir),
+        File.expand_path("../libexec", dir),               # brew cellar layout
+        File.expand_path("..", dir)                        # libexec/bin/hive → libexec
+      ]
+      candidates.find { |c| asset_root?(c) }
+    end
+
+    def resolve_executable_path
+      return $PROGRAM_NAME if File.exist?($PROGRAM_NAME)
+
+      which = `command -v hive 2>/dev/null`.strip
+      which.empty? ? nil : which
+    rescue StandardError
+      nil
+    end
+
+    def hive_home_override
+      env = ENV["HIVE_HOME"]
+      return nil if env.nil? || env.empty?
+
+      File.expand_path(env)
+    end
+
+    def xdg_base(env_key, default_tilde)
+      env = ENV[env_key]
+      if env && !env.empty?
+        File.expand_path(env)
+      else
+        File.expand_path(default_tilde)
+      end
+    end
+  end
+end
diff --git a/lib/hive/service.rb b/lib/hive/service.rb
new file mode 100644
index 00000000..13fb1d1d
--- /dev/null
+++ b/lib/hive/service.rb
@@ -0,0 +1,245 @@
+# frozen_string_literal: true
+
+require "erb"
+require "fileutils"
+require "open3"
+require "hive/paths"
+
+module Hive
+  # Platform service registration for the hive daemon (U6 / R11).
+  #
+  # macOS  → launchd agent plist under ~/Library/LaunchAgents
+  # Linux  → systemd --user unit under ~/.config/systemd/user
+  #
+  # Registration is always explicit (via `hive init` prompt or
+  # `hive daemon` helpers). Never silent-autostart.
+  class Service
+    LABEL = "com.ivankuznetsov.hive-daemon"
+    SYSTEMD_UNIT = "hive-daemon.service"
+
+    # Injectable runner for tests: callable(args_array) → [stdout, stderr, status]
+    attr_reader :runner, :platform
+
+    def initialize(binary_path: nil, runner: nil, platform: nil, home: ENV["HOME"])
+      @binary_path = binary_path
+      @runner = runner || method(:default_runner)
+      @platform = platform || detect_platform
+      @home = home || File.expand_path("~")
+    end
+
+    def binary_path
+      @binary_path ||= resolve_binary_path
+    end
+
+    def registered?
+      File.exist?(unit_path)
+    end
+
+    def available?
+      case @platform
+      when :macos
+        command_exists?("launchctl")
+      when :linux
+        command_exists?("systemctl") && user_systemd_available?
+      else
+        false
+      end
+    end
+
+    def unavailable_reason
+      return nil if available?
+
+      case @platform
+      when :macos
+        "launchctl not found; install Xcode CLT or register the daemon manually"
+      when :linux
+        if !command_exists?("systemctl")
+          "systemctl not found; install systemd or run `hive daemon start` in the foreground"
+        else
+          "systemd --user is unavailable in this environment " \
+            "(containers/WSL2 often lack a user session). " \
+            "Run `hive daemon start --detach` instead, or enable lingering: " \
+            "`loginctl enable-linger $USER`"
+        end
+      else
+        "service registration is not supported on this platform"
+      end
+    end
+
+    # Write the unit/plist. Does not enable or start.
+    def register!
+      FileUtils.mkdir_p(File.dirname(unit_path))
+      FileUtils.mkdir_p(log_dir)
+      File.write(unit_path, render_unit)
+      true
+    end
+
+    def unregister!
+      stop! if running?
+      disable! if registered?
+      FileUtils.rm_f(unit_path)
+      true
+    end
+
+    def enable!
+      register! unless registered?
+      case @platform
+      when :macos
+        run!(%W[launchctl load -w #{unit_path}])
+      when :linux
+        run!(%w[systemctl --user daemon-reload])
+        run!(%W[systemctl --user enable #{SYSTEMD_UNIT}])
+      end
+      true
+    end
+
+    def disable!
+      case @platform
+      when :macos
+        run!(%W[launchctl unload -w #{unit_path}]) if File.exist?(unit_path)
+      when :linux
+        run!(%W[systemctl --user disable #{SYSTEMD_UNIT}]) if registered?
+      end
+      true
+    rescue ServiceError
+      # Best-effort disable during uninstall.
+      false
+    end
+
+    def start!
+      enable!
+      case @platform
+      when :macos
+        run!(%W[launchctl start #{LABEL}])
+      when :linux
+        run!(%W[systemctl --user start #{SYSTEMD_UNIT}])
+      end
+      true
+    end
+
+    def stop!
+      case @platform
+      when :macos
+        run!(%W[launchctl stop #{LABEL}]) if registered?
+      when :linux
+        run!(%W[systemctl --user stop #{SYSTEMD_UNIT}]) if registered?
+      end
+      true
+    rescue ServiceError
+      false
+    end
+
+    def status
+      return :unregistered unless registered?
+      return :running if running?
+
+      :stopped
+    end
+
+    def running?
+      case @platform
+      when :macos
+        out, _err, status = @runner.call(%W[launchctl list #{LABEL}])
+        status.success? && out.to_s.lines.any? { |l| l.include?(LABEL) || l =~ /^\d+/ }
+      when :linux
+        _out, _err, status = @runner.call(%W[systemctl --user is-active #{SYSTEMD_UNIT}])
+        status.success?
+      else
+        false
+      end
+    end
+
+    def unit_path
+      case @platform
+      when :macos
+        File.join(@home, "Library", "LaunchAgents", "#{LABEL}.plist")
+      when :linux
+        File.join(@home, ".config", "systemd", "user", SYSTEMD_UNIT)
+      else
+        File.join(Hive::Paths.state_dir, "service-unit")
+      end
+    end
+
+    def log_dir
+      File.join(Hive::Paths.state_dir, "daemon")
+    end
+
+    def render_unit
+      case @platform
+      when :macos
+        render_template("hive-daemon.plist.erb")
+      when :linux
+        render_template("hive-daemon.service.erb")
+      else
+        raise ServiceError, "cannot render unit for platform #{@platform}"
+      end
+    end
+
+    class ServiceError < Hive::Error
+      def exit_code
+        Hive::ExitCodes::GENERIC
+      end
+    end
+
+    private
+
+    def render_template(name)
+      path = Hive::Paths.template_path(File.join("service", name))
+      unless File.exist?(path)
+        path = File.expand_path("../../templates/service/#{name}", __dir__)
+      end
+      ERB.new(File.read(path), trim_mode: "-").result(binding)
+    end
+
+    def resolve_binary_path
+      candidates = [
+        ENV["HIVE_BIN"],
+        $PROGRAM_NAME,
+        `command -v hive 2>/dev/null`.strip
+      ].compact.reject(&:empty?)
+      candidates.each do |c|
+        abs = File.expand_path(c)
+        return abs if File.file?(abs) && File.executable?(abs)
+      end
+      File.expand_path("../../../bin/hive", __dir__)
+    end
+
+    def detect_platform
+      case RUBY_PLATFORM
+      when /darwin/ then :macos
+      when /linux/  then :linux
+      else :unknown
+      end
+    end
+
+    def command_exists?(name)
+      return false if name.nil? || name.empty?
+
+      ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).any? do |dir|
+        next if dir.empty?
+
+        File.executable?(File.join(dir, name))
+      end
+    end
+
+    def user_systemd_available?
+      _out, _err, status = @runner.call(%w[systemctl --user is-system-running])
+      # offline / running / degraded all mean the bus is reachable enough
+      # to accept unit operations; "failed" connection is the bad case.
+      status.exitstatus != 1 || _err.to_s !~ /Failed to connect|No such file/i
+    rescue StandardError
+      false
+    end
+
+    def run!(args)
+      out, err, status = @runner.call(args)
+      return [out, err, status] if status.success?
+
+      raise ServiceError, "service command failed (#{args.join(' ')}): #{err.to_s.strip}"
+    end
+
+    def default_runner(args)
+      Open3.capture3(*args)
+    end
+  end
+end
diff --git a/lib/hive/stages/base.rb b/lib/hive/stages/base.rb
index 7d19d3cf..6ddc1a04 100644
--- a/lib/hive/stages/base.rb
+++ b/lib/hive/stages/base.rb
@@ -24,7 +24,7 @@ module Hive
       end
 
       def render(template_name, bindings_obj)
-        path = File.expand_path("../../../templates/#{template_name}", __dir__)
+        path = resolve_builtin_template(template_name)
         ERB.new(File.read(path), trim_mode: "-").result(bindings_obj.binding_for_erb)
       end
 
@@ -43,6 +43,23 @@ module Hive
         File.expand_path(File.join(task_folder, "..", "..", ".."))
       end
 
+      # Built-in templates: prefer source-checkout / install_root (U2), fall
+      # back to the path relative to this file for hermetic unit tests that
+      # ship the templates next to lib/.
+      def resolve_builtin_template(name)
+        require "hive/paths"
+        candidates = [
+          Hive::Paths.template_path(name),
+          File.expand_path("../../../templates/#{name}", __dir__)
+        ].uniq
+        candidates.each do |builtin|
+          return builtin if File.exist?(builtin)
+        end
+        raise Hive::ConfigError,
+              "prompt_template #{name.inspect} not found among built-ins " \
+              "(tried: #{candidates.join(', ')})"
+      end
+
       # Resolve a prompt-template name to an absolute, validated path.
       # Two cases:
       #   1. A bare basename (no slashes) → built-in template under
@@ -60,13 +77,7 @@ module Hive
         raise Hive::ConfigError, "prompt_template name cannot be blank" if name.nil? || name.to_s.empty?
 
         if !name.include?("/") && !File.absolute_path?(name)
-          # Built-in template lookup.
-          builtin = File.expand_path("../../../templates/#{name}", __dir__)
-          unless File.exist?(builtin)
-            raise Hive::ConfigError,
-                  "prompt_template #{name.inspect} not found among built-ins (#{builtin})"
-          end
-          return builtin
+          return resolve_builtin_template(name)
         end
 
         # Custom template — must resolve under <state_dir>/templates/.
diff --git a/lib/hive/version.rb b/lib/hive/version.rb
new file mode 100644
index 00000000..c0f12964
--- /dev/null
+++ b/lib/hive/version.rb
@@ -0,0 +1,7 @@
+# frozen_string_literal: true
+
+module Hive
+  # Single source of truth for the package version. Keep in sync with
+  # git tags (`vX.Y.Z`). Release tooling verifies tag == VERSION.
+  VERSION = "0.1.0"
+end
diff --git a/packaging/aur/.SRCINFO b/packaging/aur/.SRCINFO
new file mode 100644
index 00000000..5dbb1188
--- /dev/null
+++ b/packaging/aur/.SRCINFO
@@ -0,0 +1,16 @@
+pkgbase = hive-bin
+	pkgdesc = Multi-agent folder-as-state software pipeline (prebuilt binary)
+	pkgver = 0.1.0
+	pkgrel = 1
+	url = https://github.com/ivankuznetsov/hive
+	arch = x86_64
+	license = MIT
+	provides = hive
+	conflicts = hive
+	options = !strip
+	source = hive-0.1.0-linux-x86_64.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v0.1.0/hive-0.1.0-linux-x86_64.tar.gz
+	source = SHA256SUMS::https://github.com/ivankuznetsov/hive/releases/download/v0.1.0/SHA256SUMS
+	sha256sums = SKIP
+	sha256sums = SKIP
+
+pkgname = hive-bin
diff --git a/packaging/aur/PKGBUILD b/packaging/aur/PKGBUILD
new file mode 100644
index 00000000..d3738881
--- /dev/null
+++ b/packaging/aur/PKGBUILD
@@ -0,0 +1,50 @@
+# Maintainer: Ivan Kuznetsov
+# Canonical in-repo copy; mirrored to the AUR package hive-bin (U5 / R4).
+pkgname=hive-bin
+pkgver=0.1.0
+pkgrel=1
+pkgdesc="Multi-agent folder-as-state software pipeline (prebuilt binary)"
+arch=('x86_64')
+url="https://github.com/ivankuznetsov/hive"
+license=('MIT')
+depends=()
+provides=('hive')
+conflicts=('hive')
+options=('!strip')
+source=(
+  "hive-${pkgver}-linux-x86_64.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v${pkgver}/hive-${pkgver}-linux-x86_64.tar.gz"
+  "SHA256SUMS::https://github.com/ivankuznetsov/hive/releases/download/v${pkgver}/SHA256SUMS"
+)
+# Placeholder; release workflow / makepkg regenerates against real artifact.
+sha256sums=('SKIP' 'SKIP')
+
+package() {
+  cd "${srcdir}"
+  # Accept either top-level hive/ dir or flat layout.
+  local root="."
+  [[ -d hive ]] && root="hive"
+
+  install -Dm755 "${root}/bin/hive" "${pkgdir}/usr/bin/hive" 2>/dev/null \
+    || install -Dm755 "${root}/hive" "${pkgdir}/usr/bin/hive"
+
+  if [[ -d "${root}/templates" ]]; then
+    install -d "${pkgdir}/usr/share/hive/templates"
+    cp -a "${root}/templates/." "${pkgdir}/usr/share/hive/templates/"
+  fi
+  if [[ -d "${root}/schemas" ]]; then
+    install -d "${pkgdir}/usr/share/hive/schemas"
+    cp -a "${root}/schemas/." "${pkgdir}/usr/share/hive/schemas/"
+  fi
+
+  # Channel marker for hive update / uninstall (KTD5 heuristic also covers pacman).
+  install -d "${pkgdir}/usr/share/hive"
+  cat > "${pkgdir}/usr/share/hive/install-channel.yml" <<EOF
+channel: aur
+version: ${pkgver}
+install_path: /usr/bin/hive
+EOF
+
+  if [[ -f "${root}/LICENSE" ]]; then
+    install -Dm644 "${root}/LICENSE" "${pkgdir}/usr/share/licenses/${pkgname}/LICENSE"
+  fi
+}
diff --git a/packaging/build_portable.sh b/packaging/build_portable.sh
new file mode 100755
index 00000000..4e22310c
--- /dev/null
+++ b/packaging/build_portable.sh
@@ -0,0 +1,92 @@
+#!/usr/bin/env bash
+# Fallback self-contained artifact: relocatable portable Ruby + vendor/bundle
+# + hive sources + wrapper (KTD1 fallback / U1).
+set -euo pipefail
+
+ROOT="$(cd "$(dirname "$0")/.." && pwd)"
+# When run from packaging/, ROOT is repo root only if we go up one — fix:
+ROOT="$(cd "$(dirname "$0")/.." && pwd)"
+# dirname packaging = repo root. Good.
+
+VERSION="$(ruby -I"${ROOT}/lib" -e 'require "hive/version"; print Hive::VERSION')"
+PLATFORM="${HIVE_PLATFORM:-}"
+if [[ -z "${PLATFORM}" ]]; then
+  os="$(uname -s)"; arch="$(uname -m)"
+  case "${os}-${arch}" in
+    Darwin-arm64|Darwin-aarch64) PLATFORM="macos-arm64" ;;
+    Darwin-x86_64) PLATFORM="macos-x86_64" ;;
+    Linux-x86_64|Linux-amd64) PLATFORM="linux-x86_64" ;;
+    *) echo "set HIVE_PLATFORM (got ${os}-${arch})" >&2; exit 1 ;;
+  esac
+fi
+
+OUT_DIR="${HIVE_DIST:-${ROOT}/dist}"
+STAGE="${OUT_DIR}/stage-hive-${VERSION}-${PLATFORM}"
+TARBALL="${OUT_DIR}/hive-${VERSION}-${PLATFORM}.tar.gz"
+
+# Optional version guard for release tags.
+if [[ -n "${HIVE_RELEASE_TAG:-}" ]]; then
+  tag="${HIVE_RELEASE_TAG#v}"
+  if [[ "${tag}" != "${VERSION}" ]]; then
+    echo "tag ${HIVE_RELEASE_TAG} != Hive::VERSION ${VERSION}" >&2
+    exit 1
+  fi
+fi
+
+rm -rf "${STAGE}"
+mkdir -p "${STAGE}/bin" "${STAGE}/lib" "${STAGE}/templates" "${STAGE}/schemas"
+
+# Copy application tree.
+cp -a "${ROOT}/lib/." "${STAGE}/lib/"
+cp -a "${ROOT}/templates/." "${STAGE}/templates/"
+cp -a "${ROOT}/schemas/." "${STAGE}/schemas/"
+cp -a "${ROOT}/Gemfile" "${ROOT}/Gemfile.lock" "${STAGE}/"
+[[ -f "${ROOT}/config.example.yml" ]] && cp "${ROOT}/config.example.yml" "${STAGE}/"
+
+# Vendor gems into the stage (standalone so no system gem home needed).
+(
+  cd "${STAGE}"
+  bundle config set --local path 'vendor/bundle'
+  bundle config set --local without 'development:test'
+  bundle install --standalone
+)
+
+# Wrapper resolves its own root and loads vendored gems + lib.
+cat > "${STAGE}/bin/hive" <<'WRAPPER'
+#!/usr/bin/env bash
+set -euo pipefail
+ROOT="$(cd "$(dirname "$0")/.." && pwd)"
+export BUNDLE_GEMFILE="${ROOT}/Gemfile"
+# Prefer portable Ruby if vendored; else system ruby (dev/CI fallback).
+if [[ -x "${ROOT}/ruby/bin/ruby" ]]; then
+  RUBY="${ROOT}/ruby/bin/ruby"
+elif command -v ruby >/dev/null 2>&1; then
+  RUBY="$(command -v ruby)"
+else
+  echo "hive: no Ruby runtime found in package or on PATH" >&2
+  exit 1
+fi
+export RUBYLIB="${ROOT}/lib${RUBYLIB:+:$RUBYLIB}"
+# standalone setup path from `bundle install --standalone`
+if [[ -f "${ROOT}/vendor/bundle/bundler/setup.rb" ]]; then
+  exec "${RUBY}" -r"${ROOT}/vendor/bundle/bundler/setup" -I"${ROOT}/lib" -e 'require "hive"; require "hive/cli"; if ARGV == ["--version"] || ARGV == ["-v"]; puts Hive::VERSION; exit 0; end; Hive::CLI.start(ARGV)' -- "$@"
+fi
+# Fallback: use bundle exec semantics via -rbundler/setup if present
+exec "${RUBY}" -I"${ROOT}/lib" -e 'require "hive"; require "hive/cli"; if ARGV == ["--version"] || ARGV == ["-v"]; puts Hive::VERSION; exit 0; end; Hive::CLI.start(ARGV)' -- "$@"
+WRAPPER
+chmod +x "${STAGE}/bin/hive"
+
+# Also expose top-level hive for simpler unpack layouts.
+ln -sfn bin/hive "${STAGE}/hive"
+
+mkdir -p "${OUT_DIR}"
+tar -czf "${TARBALL}" -C "${OUT_DIR}" "stage-hive-${VERSION}-${PLATFORM}"
+# Repack with cleaner top-level name `hive/` for installers.
+CLEAN_STAGE="${OUT_DIR}/hive"
+rm -rf "${CLEAN_STAGE}"
+mv "${STAGE}" "${CLEAN_STAGE}"
+tar -czf "${TARBALL}" -C "${OUT_DIR}" hive
+rm -rf "${CLEAN_STAGE}"
+
+echo "built ${TARBALL}"
+sha256sum "${TARBALL}" 2>/dev/null || shasum -a 256 "${TARBALL}"
diff --git a/packaging/homebrew/hive.rb.erb b/packaging/homebrew/hive.rb.erb
new file mode 100644
index 00000000..ae44e0f0
--- /dev/null
+++ b/packaging/homebrew/hive.rb.erb
@@ -0,0 +1,46 @@
+# frozen_string_literal: true
+
+# Homebrew formula template for the ivankuznetsov/hive tap (U4 / R3).
+# Release workflow renders VERSION / SHA256 placeholders into Formula/hive.rb.
+class Hive < Formula
+  desc "Multi-agent folder-as-state software pipeline"
+  homepage "https://github.com/ivankuznetsov/hive"
+  version "<%= version %>"
+  license "MIT"
+
+  on_macos do
+    on_arm do
+      url "https://github.com/ivankuznetsov/hive/releases/download/v<%= version %>/hive-<%= version %>-macos-arm64.tar.gz"
+      sha256 "<%= sha256_macos_arm64 %>"
+    end
+  end
+
+  on_linux do
+    on_intel do
+      url "https://github.com/ivankuznetsov/hive/releases/download/v<%= version %>/hive-<%= version %>-linux-x86_64.tar.gz"
+      sha256 "<%= sha256_linux_x86_64 %>"
+    end
+  end
+
+  def install
+    # Tarball contains a top-level hive/ directory (or flat bin/hive).
+    if File.directory?("hive")
+      prefix.install Dir["hive/*"]
+    else
+      prefix.install Dir["*"]
+    end
+    # Prefer bin/hive; fall back to top-level hive.
+    if (bin_hive = prefix/"bin/hive").exist?
+      bin.install_symlink bin_hive => "hive"
+    elsif (root_hive = prefix/"hive").exist?
+      bin.install_symlink root_hive => "hive"
+    end
+  end
+
+  test do
+    assert_match version.to_s, shell_output("#{bin}/hive --version")
+  end
+
+  # No `service` block — daemon registration is owned by `hive init` (R11)
+  # and must stay prompt-driven.
+end
diff --git a/packaging/install.sh b/packaging/install.sh
new file mode 100755
index 00000000..651ec371
--- /dev/null
+++ b/packaging/install.sh
@@ -0,0 +1,204 @@
+#!/usr/bin/env bash
+# Hive installer — curl | bash one-liner (U3 / R5).
+#
+#   curl -fsSL https://github.com/ivankuznetsov/hive/releases/latest/download/install.sh | bash
+#   HIVE_VERSION=v0.1.0 curl -fsSL .../install.sh | bash
+#
+# Never uses sudo. Never edits shell rc files. Prints PATH guidance instead.
+set -euo pipefail
+
+REPO="${HIVE_REPO:-ivankuznetsov/hive}"
+VERSION="${HIVE_VERSION:-latest}"
+PREFIX="${HIVE_PREFIX:-${HOME}/.local}"
+BIN_DIR="${HIVE_BIN_DIR:-${PREFIX}/bin}"
+SHARE_DIR="${HIVE_SHARE_DIR:-${PREFIX}/share/hive}"
+GITHUB_API="${HIVE_GITHUB_API:-https://api.github.com}"
+GITHUB_RELEASES="${HIVE_GITHUB_RELEASES:-https://github.com/${REPO}/releases}"
+
+info()  { printf 'hive-install: %s\n' "$*" >&2; }
+die()   { printf 'hive-install: error: %s\n' "$*" >&2; exit 1; }
+
+detect_platform() {
+  local os arch
+  os="$(uname -s)"
+  arch="$(uname -m)"
+  case "${os}" in
+    Darwin)
+      case "${arch}" in
+        arm64|aarch64) echo "macos-arm64" ;;
+        x86_64)        echo "macos-x86_64" ;; # tier-2 best-effort
+        *) die "unsupported macOS architecture: ${arch}. See https://github.com/${REPO}#install" ;;
+      esac
+      ;;
+    Linux)
+      case "${arch}" in
+        x86_64|amd64) echo "linux-x86_64" ;;
+        aarch64|arm64) die "linux arm64 is tier-2 (no release artifact yet). Build from source: https://github.com/${REPO}" ;;
+        *) die "unsupported Linux architecture: ${arch}. See https://github.com/${REPO}#install" ;;
+      esac
+      ;;
+    *)
+      die "unsupported OS: ${os}. Tier-1 targets: macOS arm64, Ubuntu 22.04+ x86_64, Arch x86_64. Manual install: https://github.com/${REPO}#install"
+      ;;
+  esac
+}
+
+resolve_version() {
+  if [[ "${VERSION}" != "latest" ]]; then
+    # Accept v0.1.0 or 0.1.0
+    if [[ "${VERSION}" == v* ]]; then
+      echo "${VERSION}"
+    else
+      echo "v${VERSION}"
+    fi
+    return
+  fi
+  # Prefer redirect of /releases/latest; fall back to API.
+  local tag
+  tag="$(curl -fsSLI -o /dev/null -w '%{url_effective}' "${GITHUB_RELEASES}/latest" 2>/dev/null | sed -n 's|.*/tag/||p' || true)"
+  if [[ -n "${tag}" && "${tag}" != *"latest" ]]; then
+    echo "${tag}"
+    return
+  fi
+  tag="$(curl -fsSL "${GITHUB_API}/repos/${REPO}/releases/latest" | sed -n 's/.*"tag_name": *"\([^"]*\)".*/\1/p' | head -1)"
+  [[ -n "${tag}" ]] || die "could not resolve latest release for ${REPO}"
+  echo "${tag}"
+}
+
+version_number() {
+  # v0.1.0 → 0.1.0
+  echo "${1#v}"
+}
+
+sha256_file() {
+  if command -v sha256sum >/dev/null 2>&1; then
+    sha256sum "$1" | awk 'NF{print $1; exit}'
+  elif command -v shasum >/dev/null 2>&1; then
+    shasum -a 256 "$1" | awk 'NF{print $1; exit}'
+  else
+    die "need sha256sum or shasum to verify release checksums"
+  fi
+}
+
+verify_checksum() {
+  local file="$1" sums="$2" base
+  base="$(basename "${file}")"
+  local expected actual
+  expected="$(grep -E "[[:space:]]${base}\$" "${sums}" | awk 'NF{print $1; exit}' || true)"
+  [[ -n "${expected}" ]] || die "no checksum entry for ${base} in SHA256SUMS"
+  actual="$(sha256_file "${file}")"
+  [[ "${expected}" == "${actual}" ]] || die "checksum mismatch for ${base}: expected ${expected}, got ${actual}"
+  info "checksum OK for ${base}"
+}
+
+is_our_hive() {
+  local bin="$1"
+  [[ -x "${bin}" ]] || return 1
+  local out
+  out="$("${bin}" --version 2>/dev/null || true)"
+  # Our version is plain semver like 0.1.0
+  [[ "${out}" =~ ^[0-9]+\.[0-9]+\.[0-9]+([.-].*)?$ ]]
+}
+
+main() {
+  command -v curl >/dev/null 2>&1 || die "curl is required"
+  command -v tar  >/dev/null 2>&1 || die "tar is required"
+
+  local platform tag ver asset_name url tmpdir tarball sums
+  platform="$(detect_platform)"
+  tag="$(resolve_version)"
+  ver="$(version_number "${tag}")"
+  asset_name="hive-${ver}-${platform}.tar.gz"
+  url="${GITHUB_RELEASES}/download/${tag}/${asset_name}"
+  sums_url="${GITHUB_RELEASES}/download/${tag}/SHA256SUMS"
+
+  info "installing hive ${tag} for ${platform}"
+  info "download: ${url}"
+
+  tmpdir="$(mktemp -d "${TMPDIR:-/tmp}/hive-install.XXXXXX")"
+  # shellcheck disable=SC2064
+  trap "rm -rf '${tmpdir}'" EXIT
+
+  tarball="${tmpdir}/${asset_name}"
+  sums="${tmpdir}/SHA256SUMS"
+  curl -fsSL "${url}" -o "${tarball}" || die "failed to download ${url}"
+  curl -fsSL "${sums_url}" -o "${sums}" || die "failed to download ${sums_url}"
+  verify_checksum "${tarball}" "${sums}"
+
+  mkdir -p "${tmpdir}/extract"
+  tar -xzf "${tarball}" -C "${tmpdir}/extract"
+
+  # Artifact layout (portable or tebako-wrapped):
+  #   hive                 (or bin/hive)
+  #   templates/ schemas/  (optional shared assets)
+  local extracted_bin=""
+  if [[ -x "${tmpdir}/extract/hive" ]]; then
+    extracted_bin="${tmpdir}/extract/hive"
+  elif [[ -x "${tmpdir}/extract/bin/hive" ]]; then
+    extracted_bin="${tmpdir}/extract/bin/hive"
+  else
+    # Single top-level directory
+    local top
+    top="$(find "${tmpdir}/extract" -mindepth 1 -maxdepth 1 -type d | head -1 || true)"
+    if [[ -n "${top}" && -x "${top}/hive" ]]; then
+      extracted_bin="${top}/hive"
+    elif [[ -n "${top}" && -x "${top}/bin/hive" ]]; then
+      extracted_bin="${top}/bin/hive"
+    fi
+  fi
+  [[ -n "${extracted_bin}" ]] || die "tarball missing hive executable"
+
+  mkdir -p "${BIN_DIR}" "${SHARE_DIR}"
+
+  # Install shared assets when present.
+  local asset_root
+  asset_root="$(dirname "${extracted_bin}")"
+  [[ "$(basename "${asset_root}")" == "bin" ]] && asset_root="$(dirname "${asset_root}")"
+  for d in templates schemas; do
+    if [[ -d "${asset_root}/${d}" ]]; then
+      rm -rf "${SHARE_DIR}/${d}"
+      cp -a "${asset_root}/${d}" "${SHARE_DIR}/${d}"
+    fi
+  done
+  # Also copy sibling share layout
+  if [[ -d "${asset_root}/share/hive" ]]; then
+    cp -a "${asset_root}/share/hive/." "${SHARE_DIR}/"
+  fi
+
+  install -m 755 "${extracted_bin}" "${BIN_DIR}/hive"
+
+  # Channel-of-record marker (KTD5).
+  mkdir -p "${SHARE_DIR}"
+  cat > "${SHARE_DIR}/install-channel.yml" <<EOF
+channel: bash
+version: ${ver}
+install_path: ${BIN_DIR}/hive
+installed_at: $(date -u +%Y-%m-%dT%H:%M:%SZ)
+EOF
+
+  # Conflict handling: if another hive is earlier on PATH, create hv symlink (KTD4).
+  local path_hive=""
+  path_hive="$(command -v hive 2>/dev/null || true)"
+  if [[ -n "${path_hive}" && "${path_hive}" != "${BIN_DIR}/hive" ]]; then
+    if ! is_our_hive "${path_hive}"; then
+      ln -sfn "${BIN_DIR}/hive" "${BIN_DIR}/hv"
+      info "conflicting 'hive' found at ${path_hive} (not ours)"
+      info "installed our binary as ${BIN_DIR}/hive and symlink ${BIN_DIR}/hv"
+      info "prefer: export PATH=\"${BIN_DIR}:\$PATH\"  # or run 'hv'"
+    fi
+  fi
+
+  if ! is_our_hive "${BIN_DIR}/hive"; then
+    die "installed binary does not respond to --version correctly"
+  fi
+
+  info "installed hive ${ver} → ${BIN_DIR}/hive"
+  info "shared assets → ${SHARE_DIR}"
+  if ! echo ":${PATH}:" | grep -q ":${BIN_DIR}:"; then
+    info "add to PATH:  export PATH=\"${BIN_DIR}:\$PATH\""
+  fi
+  info "verify:  hive --version && hive doctor"
+  info "next:    hive init"
+}
+
+main "$@"
diff --git a/packaging/tebako/press.sh b/packaging/tebako/press.sh
new file mode 100755
index 00000000..3f968eff
--- /dev/null
+++ b/packaging/tebako/press.sh
@@ -0,0 +1,35 @@
+#!/usr/bin/env bash
+# Attempt a Tebako press of hive. Exit non-zero on failure so CI can fall
+# back to packaging/build_portable.sh (KTD1).
+set -euo pipefail
+
+ROOT="$(cd "$(dirname "$0")/../.." && pwd)"
+OUT_DIR="${HIVE_TEBAKO_OUT:-${ROOT}/dist/tebako}"
+ENTRY="${ROOT}/bin/hive"
+mkdir -p "${OUT_DIR}"
+
+if ! command -v tebako >/dev/null 2>&1; then
+  echo "tebako not installed; install via: gem install tebako" >&2
+  exit 2
+fi
+
+# Verify tag == VERSION when releasing.
+if [[ -n "${HIVE_RELEASE_TAG:-}" ]]; then
+  ruby -I"${ROOT}/lib" -e "
+    require 'hive/version'
+    tag = ENV.fetch('HIVE_RELEASE_TAG').sub(/\\Av/, '')
+    abort \"tag #{tag} != Hive::VERSION #{Hive::VERSION}\" unless tag == Hive::VERSION
+  "
+fi
+
+echo "pressing hive with tebako → ${OUT_DIR}/hive" >&2
+tebako press \
+  --root="${ROOT}" \
+  --entry-point="bin/hive" \
+  --output="${OUT_DIR}/hive" \
+  --Ruby=3.4.0
+
+chmod +x "${OUT_DIR}/hive"
+# Smoke: version must print.
+"${OUT_DIR}/hive" --version
+echo "tebako press OK" >&2
